searchNodes=[{"doc":"The main module implements Douglas Crockford's Base32 encoding.","ref":"CrockfordBase32.html","title":"CrockfordBase32","type":"module"},{"doc":"Decode the encoded to an string, all hyphen(s) are removed and ignore the encoded's case. If the encoded string be with a check symbol, require to use checksum: true in decoding. Example iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66&quot; ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66C&quot; , checksum : true ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66D&quot; , checksum : true ) { :error , &quot;invalid_checksum&quot; } Options The same to the options of decode_to_integer/2 .","ref":"CrockfordBase32.html#decode_to_binary/2","title":"CrockfordBase32.decode_to_binary/2","type":"function"},{"doc":"Decode the encoded to an integer, all hyphen(s) are removed and ignore the encoded's case. If the encoded string be with a check symbol, require to use checksum: true in decoding. Example iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16JD&quot; , checksum : true ) { :ok , 1234 } iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16j&quot; ) { :ok , 1234 } iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16j*&quot; , checksum : true ) { :error , &quot;invalid_checksum&quot; } Options :checksum , optional, a boolean, by defaults to false means expect input the encoded string without a check symbol in its tail, if set it as true , please ensure input encoded is a string be with a check symbol, or return {:error, &quot;invalid_checksum&quot;} .","ref":"CrockfordBase32.html#decode_to_integer/2","title":"CrockfordBase32.decode_to_integer/2","type":"function"},{"doc":"Encode an integer or a binary in Crockford's Base32. After encoded, the return string only contains these characters set( &quot;0123456789ABCDEFGHJKMNPQRSTVWXYZ&quot; , 10 digits and 22 letters, excluding &quot;I&quot; , &quot;L&quot; , &quot;O&quot; and &quot;U&quot; ), if set checksum: true , there would be with one of these check symbols( &quot;*~$=U&quot; ) or the previous 10 digits and 22 letters as the last character. Example iex&gt; CrockfordBase32 . encode ( 1234567 ) &quot;15NM7&quot; iex&gt; CrockfordBase32 . encode ( 1234567 , checksum : true ) &quot;15NM7S&quot; iex&gt; CrockfordBase32 . encode ( 1234567 , split_size : 3 ) &quot;15N-M7&quot; iex&gt; CrockfordBase32 . encode ( 1234567 , split_size : 3 , checksum : true ) &quot;15N-M7S&quot; Options :checksum , optional, a boolean, by defaults to false , if set it as true will calculate a check symbol and append it to the return string. :split_size , optional, a positive integer, if set it will use it as a step size to split the return string with hyphen(s).","ref":"CrockfordBase32.html#encode/2","title":"CrockfordBase32.encode/2","type":"function"},{"doc":"An Elixir Implementation of Douglas Crockford's Base32 encoding. Please see https://www.crockford.com/base32.html . This library can encode an integer or a binary in Crockford's Base32, and also provide the way to decode the corresponding encoded.","ref":"readme.html","title":"CrockfordBase32","type":"extras"},{"doc":"def deps do [ { :crockford_base32 , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"CrockfordBase32 - Installation","type":"extras"},{"doc":"Encode Encode an integer: iex&gt; CrockfordBase32 . encode ( 1234 ) &quot;16J&quot; Encode an integer with checksum: true : iex&gt; CrockfordBase32 . encode ( 1234 , checksum : true ) &quot;16JD&quot; Encode an inetger, and insert hyphens (-) per the step size(via split_size ) in encoded result: iex&gt; CrockfordBase32 . encode ( 1234 , split_size : 2 ) &quot;16-J&quot; iex&gt; CrockfordBase32 . encode ( 1234 , split_size : 1 ) &quot;1-6-J&quot; iex&gt; CrockfordBase32 . encode ( 1234 , split_size : 1 , checksum : true ) &quot;1-6-J-D&quot; Encode a binary, and optional split_size and checksum options are both working: iex&gt; CrockfordBase32 . encode ( &lt;&lt; 12345678 :: size ( 48 ) &gt;&gt; ) &quot;00001F319R&quot; iex&gt; CrockfordBase32 . encode ( &quot;abc&quot; ) &quot;C5H66&quot; iex&gt; CrockfordBase32 . encode ( &quot;abc&quot; , checksum : true ) &quot;C5H66C&quot; iex&gt; CrockfordBase32 . encode ( &quot;abc&quot; , checksum : true , split_size : 3 ) &quot;C5H-66C&quot; Decode There will internally remove all hyphen(s) before decoding. Decode the encoded to an integer: iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16J&quot; ) { :ok , 1234 } iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16-J&quot; ) { :ok , 1234 } iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16-j&quot; ) { :ok , 1234 } With a check symbol, and decode the encoded to an integer: iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16JD&quot; , checksum : true ) { :ok , 1234 } iex&gt; CrockfordBase32 . decode_to_integer ( &quot;16J1&quot; , checksum : true ) { :error , &quot;invalid_checksum&quot; } Decode the encoded to a binary: iex&gt; CrockfordBase32 . decode_to_binary ( &quot;00001F319R&quot; ) { :ok , &lt;&lt; 0 , 0 , 0 , 188 , 97 , 78 &gt;&gt; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66&quot; ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H-66&quot; ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;c5H-66&quot; ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;c5h-66&quot; ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;c5h66&quot; ) { :ok , &quot;abc&quot; } With a check symbol, and decode the encoded to a binary: iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66C&quot; , checksum : true ) { :ok , &quot;abc&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &quot;C5H66D&quot; , checksum : true ) { :error , &quot;invalid_checksum&quot; } Some invalid cases: iex&gt; CrockfordBase32 . decode_to_binary ( &quot;F1&quot; ) { :error , &quot;invalid&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &lt;&lt; 1 , 2 , 3 &gt;&gt; ) { :error , &quot;invalid&quot; } iex&gt; CrockfordBase32 . decode_to_binary ( &lt;&lt; &gt;&gt; ) { :error , &quot;invalid&quot; } iex&gt; CrockfordBase32 . decode_to_integer ( &lt;&lt; 1 , 2 , 3 &gt;&gt; ) { :error , &quot;invalid&quot; } iex&gt; CrockfordBase32 . decode_to_integer ( &lt;&lt; &gt;&gt; ) { :error , &quot;invalid&quot; } Fixed Size Encoding In some cases, you may want to encode the fixed size bytes, we can do this be with a better performance leverages the benefit of the pattern match of Elixir/Erlang. I use this feature to implement a ULID in Elixir. Refer ULID specification , a ULID concatenates a UNIX timestamp in milliseconds(a 48 bit integer) and a randomness in 80 bits, since an integer in bits are padded with some &lt;&lt;0::1&gt;&gt; leading when needed, and a ULID in 128 bits after encoded its length is 26 (can be divisible by 5), apply the fixed size encoding with type: :integer can efficiently encode/decode a ULID, for example: defmoule ULID do defmoule Base32.Bits128 do use CrockfordBase32 , bits_size : 128 , type : :integer # Optional, defaults to `:bitstring` end end Then we can use ULID.Base32.Bits128 to encode/decode a 128 bit binary which concatenates an integer (as UNIX timestamp in millisecond) in 48 bits and a random generated in 80 bits.","ref":"readme.html#usage","title":"CrockfordBase32 - Usage","type":"extras"},{"doc":"These libraries or tools are very helpful in understanding and reference, thanks! TheRealReal/ecto-ulid shiguredo/base32_clockwork voldy/base32_crockford levinalex/base32 jbittel/base32-crockford dcode.fr's crockford-base32 encoding","ref":"readme.html#credits","title":"CrockfordBase32 - Credits","type":"extras"}]